Disassembly Listing for PWM1
Generated From:
C:/Users/Pavel/MPLABXProjects/PWM1.X/dist/default/production/PWM1.X.production.elf
7.6.2017 11:37:55

---  C:/Users/Pavel/MPLABXProjects/PWM1.X/vcf1.c  -------------------------------------------------------
1:             /* 
2:              * File:   vcf1.c
3:              * Author: Pavel
4:              *
5:              * Created on 11. dubna 2017, 14:29
6:              */
7:             
8:             
9:             
10:            #pragma config FOSC = INTOSC        //  -- internal oscillator
11:            #pragma config PLLEN = ON           //  -- PLL on
12:            #pragma config WDTE = OFF           //  -- watchdog
13:            #pragma config BOREN = OFF          //  -- brownout reset
14:            #pragma config LVP =   OFF          //  -- low voltage programming off
15:            #pragma config MCLRE  =  ON         //  -- mclear on
16:            #pragma config PWRTE = ON           //  -- power up timer
17:            
18:            #include <xc.h>
19:            
20:            void main() {
21:                OSCCON = 0xF8; //32 MHz & PLL
078C  30F8     MOVLW 0xF8
078D  0021     MOVLB 0x1
078E  0099     MOVWF OSCCON
22:                PORTA = 0;
078F  0020     MOVLB 0x0
0790  018C     CLRF PORTA
23:                LATA = 0;
0791  0022     MOVLB 0x2
0792  018C     CLRF LATA
24:                PORTC = 0;
0793  0020     MOVLB 0x0
0794  018E     CLRF PORTC
25:                LATC = 0;
0795  0022     MOVLB 0x2
0796  018E     CLRF LATC
26:                TRISC = 7;  
0797  3007     MOVLW 0x7
0798  0021     MOVLB 0x1
0799  008E     MOVWF TRISC
27:                ANSELC = 7; //RC0, RC1, RC2 analog in
079A  3007     MOVLW 0x7
079B  0023     MOVLB 0x3
079C  008E     MOVWF ANSELC
28:                ANSELA = 0;
079D  018C     CLRF ANSELA
29:            
30:                OPTION_REG = 0;
079E  0021     MOVLB 0x1
079F  0195     CLRF OPTION_REG
31:            
32:                WPUC2 = 0; //pull up off
07A0  0024     MOVLB 0x4
07A1  110E     BCF WPUC, 0x2
33:                WPUC1 = 0;
07A2  108E     BCF WPUC, 0x1
34:                WPUC0 = 0;
07A3  100E     BCF WPUC, 0x0
35:            
36:                T2CLKCON = 0;   // T2 clock Fosc/4
07A4  0020     MOVLB 0x0
07A5  019E     CLRF T2CLKCON
37:                T2CON = 0x80;   //T2CON ON  prescaler 1:1
07A6  3080     MOVLW 0x80
07A7  009C     MOVWF T2CON
38:                PR2 = 0x9F;     //fo = 50 kHz
07A8  309F     MOVLW 0x9F
07A9  009B     MOVWF T2PR
39:                CCP1CON = 0xFC; // CCP1 PWM ON
07AA  30FC     MOVLW 0xFC
07AB  0025     MOVLB 0x5
07AC  0093     MOVWF CCP1CON
40:                CCP2CON = 0xFC; // CCP2 PWM ON
07AD  30FC     MOVLW 0xFC
07AE  009A     MOVWF CCP2CON
41:                ADCON1 = 0x70;  // ADC ON  
07AF  3070     MOVLW 0x70
07B0  0021     MOVLB 0x1
07B1  009E     MOVWF ADCON1
42:                ADON = 1;
07B2  141D     BSF ADCON0, 0x0
43:                DAC1CON0 = 0xA4; //DAC ON
07B3  30A4     MOVLW 0xA4
07B4  0022     MOVLB 0x2
07B5  0098     MOVWF DAC1CON0
44:            
45:                while (1) {
07FD  2FB6     GOTO 0x7B6
46:                    ADCON0bits.CHS = 4; //RC0 IN
07B6  0021     MOVLB 0x1
07B7  081D     MOVF ADCON0, W
07B8  3983     ANDLW 0x83
07B9  3810     IORLW 0x10
07BA  009D     MOVWF ADCON0
47:                    _delay(100);
07BB  3021     MOVLW 0x21
07BC  00F0     MOVWF 0xF0
07BD  0BF0     DECFSZ 0xF0, F
07BE  2FBD     GOTO 0x7BD
48:                    GO = 1;
07BF  0021     MOVLB 0x1
07C0  149D     BSF ADCON0, 0x1
49:                    while (GO);
07C1  189D     BTFSC ADCON0, 0x1
07C2  2FC1     GOTO 0x7C1
50:                    _delay(10);
07C3  3003     MOVLW 0x3
07C4  00F0     MOVWF 0xF0
07C5  0BF0     DECFSZ 0xF0, F
07C6  2FC5     GOTO 0x7C5
51:                    CCPR1L = ADRESL;    //RC5 PWM OUT
07C7  0021     MOVLB 0x1
07C8  081B     MOVF ADRES, W
07C9  0025     MOVLB 0x5
07CA  0091     MOVWF CCPR1
52:                    CCPR1H = ADRESH;
07CB  0021     MOVLB 0x1
07CC  081C     MOVF ADRESH, W
07CD  0025     MOVLB 0x5
07CE  0092     MOVWF CCPR1H
53:            
54:                    ADCON0bits.CHS = 5; //RC1 IN
07CF  0021     MOVLB 0x1
07D0  081D     MOVF ADCON0, W
07D1  3983     ANDLW 0x83
07D2  3814     IORLW 0x14
07D3  009D     MOVWF ADCON0
55:                    _delay(100);
07D4  3021     MOVLW 0x21
07D5  00F0     MOVWF 0xF0
07D6  0BF0     DECFSZ 0xF0, F
07D7  2FD6     GOTO 0x7D6
56:                    GO = 1;
07D8  0021     MOVLB 0x1
07D9  149D     BSF ADCON0, 0x1
57:                    while (GO);
07DA  189D     BTFSC ADCON0, 0x1
07DB  2FDA     GOTO 0x7DA
58:                    _delay(10);
07DC  3003     MOVLW 0x3
07DD  00F0     MOVWF 0xF0
07DE  0BF0     DECFSZ 0xF0, F
07DF  2FDE     GOTO 0x7DE
59:            
60:                    CCPR2L = ADRESL;    //RC3 PWM OUT
07E0  0021     MOVLB 0x1
07E1  081B     MOVF ADRES, W
07E2  0025     MOVLB 0x5
07E3  0098     MOVWF CCPR2
61:                    CCPR2H = ADRESH;
07E4  0021     MOVLB 0x1
07E5  081C     MOVF ADRESH, W
07E6  0025     MOVLB 0x5
07E7  0099     MOVWF CCPR2H
62:            
63:                    ADCON0bits.CHS = 6; //RC2 IN
07E8  0021     MOVLB 0x1
07E9  081D     MOVF ADCON0, W
07EA  3983     ANDLW 0x83
07EB  3818     IORLW 0x18
07EC  009D     MOVWF ADCON0
64:                    _delay(100);
07ED  3021     MOVLW 0x21
07EE  00F0     MOVWF 0xF0
07EF  0BF0     DECFSZ 0xF0, F
07F0  2FEF     GOTO 0x7EF
65:                    GO = 1;
07F1  0021     MOVLB 0x1
07F2  149D     BSF ADCON0, 0x1
66:                    while (GO);
07F3  189D     BTFSC ADCON0, 0x1
07F4  2FF3     GOTO 0x7F3
67:                    _delay(10);
07F5  3003     MOVLW 0x3
07F6  00F0     MOVWF 0xF0
07F7  0BF0     DECFSZ 0xF0, F
07F8  2FF7     GOTO 0x7F7
68:                    DAC1CON1 = ADRESH^0xFF; // RA1 REF IN, RA0 DAC OUT, inverse    
07F9  0021     MOVLB 0x1
07FA  091C     COMF ADRESH, W
07FB  0022     MOVLB 0x2
07FC  0099     MOVWF DAC1CON1
07FD  2FB6     GOTO 0x7B6
69:                }//while   
70:            }//main
